Subject: RE: [SIP] Registration Authentication

From: Jonathan Rosenberg <[email-masked]>
Date: Fri, 27 Apr 2001 03:58:24 -0400

> -----Original Message-----
> From: James Undery [mailto:[email-masked]]
> Sent: Thursday, April 26, 2001 12:29 PM
> To: SIP List
> Subject: [SIP] Registration Authentication
> 
> 
> Hi,
> 
> Now the second version of the sip-register draft is out, it may be a
> good time to bring up an issue I don't think was resolved 
> last time. In
> 
>  http://lists.bell-labs.com/pipermail/sip/2000q4/003116.html
> 
> it was mentioned REGISTER is totally unprotected from by digest
> authentication, i.e. auth-int does nothing to prevent someone from
> replaying a successful registration with a different Contact 
> header(s).

Thats not entirely true. A replay will succeed only until the nonce expires.
Assuming fairly short nonce lifetimes (a good idea, in general), that means
you need to replay within a few seconds. That is possible, of course.

> As PGP has been depreciated (and justifiably so) we are left 
> without any
> method, however weak, of authenticating REGISTER requests.
> 
> I am inclined to suggest deprecating REGISTER, however, I won't and
> suggest instead we allow (or recommend) the contact headers 
> are repeated
> in the REGISTER message body.

Err, deprecating register seems a bit extreme to deal with this problem.
Also a bit too late.

Anyway, I see a few solutions:

1. we define a real security framework that supports true integrity, both
using public key and shared secret. No doubt this will require copying the
signed thing into the bodies. I know work is underway on this, but it will
be a while.

2. as a shorter term solution, we define a variant on digest which includes
select header fields in the siganture, i.e., qop=auth-sip. We could specify
this faster, but its still gonna require a complete extension.

3. There might be another way..... no extensions needed. Complete integrity
protection. More to come.

-Jonathan R.

---
Jonathan D. Rosenberg                       72 Eagle Rock Ave.
Chief Scientist                             First Floor
dynamicsoft                                 East Hanover, NJ 07936
[email-masked]                     FAX:   (973) 952-5050
http://www.jdrosen.net                      PHONE: (973) 952-5000
http://www.dynamicsoft.com

_______________________________________________
This list is for continuing development of the SIP protocol.
The sip-implementor's list is the place to discuss implementation,
and to receive advice on understanding existing sip.
To subscribe to it, send mail to 
[email-masked] with "subscribe" in the body.

---

From: James Undery <[email-masked]>
Date: Fri, 27 Apr 2001 11:05:51 +0100

> you need to replay within a few seconds. That is possible, of course.

One phrase "Man in the Middle", whatever your nonce lifetime is, even if it's
based on the transaction, you are really vunerable.

> signed thing into the bodies. I know work is underway on this, but it will

That's definately the best idea as this example shows where the differences
between SIP and HTTP break the usefulness of HTTP Authentication to SIP.

> protection. More to come.

James Undery

---

From: Henning Schulzrinne <[email-masked]>
Date: Fri, 27 Apr 2001 07:03:11 -0700

One solution is to simply register via SSL. Avoids these issues and
requires no SIP changes.

> based on the transaction, you are really vunerable.

As long as the server keeps a log of recent registrations (pretty
trivial, if it remembers the nonce for the last update), it can detect
replay attempts. Doesn't address modifications of the request by The
Man, but it's the only way to prevent short-period replay. (IPsec does
something that's very roughly similar.)